Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
path: root/src
diff options
context:
space:
mode:
authorJelle van der Waa <jelle@archlinux.org>2023-11-05 16:11:12 +0100
committerChristian Heusel <christian@heusel.eu>2024-01-10 19:44:15 +0100
commite6f7aa395fabc7eca1ee4d93e454d2551cea505c (patch)
tree57a604c65a7df94072518db91f95f53cd9bbd6b4 /src
parente413b65df3dcddeb94da2defb53ab17ef2a8558d (diff)
feat(version): introduce version check subcommand
The version subcommand handles pkgver related commands, the first subcommand being `check`. Check runs nvchecker if a `.nvchecker.toml` file exists and compares the current pkgver with the latest release. Introduces nvchecker as optional dependency which has to be installed in order to use this particular subcommand. BREAKING CHANGE: formerly pkgctl version would output the version of the pkgctl tool, now it is used as a version related subcommand. Fixes #140 Component: pkgctl version Component: pkgctl version check Co-authored-by: Christian Heusel <christian@heusel.eu>
Diffstat (limited to 'src')
-rw-r--r--src/lib/version.sh (renamed from src/lib/version/version.sh)31
-rw-r--r--src/lib/version/check.sh97
-rw-r--r--src/pkgctl.in20
3 files changed, 133 insertions, 15 deletions
diff --git a/src/lib/version/version.sh b/src/lib/version.sh
index d00a460..826b306 100644
--- a/src/lib/version/version.sh
+++ b/src/lib/version.sh
@@ -7,41 +7,50 @@ DEVTOOLS_INCLUDE_VERSION_SH=1
_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
-source /usr/share/makepkg/util/message.sh
-
set -e
pkgctl_version_usage() {
local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
cat <<- _EOF_
- Usage: ${COMMAND} [OPTIONS]
+ Usage: ${COMMAND} [COMMAND] [OPTIONS]
+
+ Package version related commands.
- Shows the current version information of pkgctl
+ COMMANDS
+ check Check if there is a newer version availble
OPTIONS
-h, --help Show this help text
-_EOF_
-}
-pkgctl_version_print() {
- cat <<- _EOF_
- pkgctl @buildtoolver@
+ EXAMPLES
+ $ ${COMMAND} check libfoo linux libbar
_EOF_
}
pkgctl_version() {
+ if (( $# < 1 )); then
+ pkgctl_version_usage
+ exit 0
+ fi
+
while (( $# )); do
case $1 in
-h|--help)
pkgctl_version_usage
exit 0
;;
+ check)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/version/check.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/version/check.sh
+ pkgctl_version_check "$@"
+ exit 0
+ ;;
*)
die "invalid argument: %s" "$1"
;;
esac
done
-
- pkgctl_version_print
}
diff --git a/src/lib/version/check.sh b/src/lib/version/check.sh
new file mode 100644
index 0000000..f6619c2
--- /dev/null
+++ b/src/lib/version/check.sh
@@ -0,0 +1,97 @@
+#!/bin/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+#
+[[ -z ${DEVTOOLS_INCLUDE_VERSION_CHECK_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_VERSION_CHECK_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+
+source /usr/share/makepkg/util/message.sh
+
+set -e
+
+pkgctl_version_check_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS] [PKGBASE]...
+
+ Uses nvchecker, a .nvchecker.toml file and the current PKGBUILD
+ pkgver to check if there is a newer package version available.
+
+ The current working directory is used if no PKGBASE is specified.
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} neovim vim
+_EOF_
+}
+
+pkgctl_version_check() {
+ local path
+ local pkgbases=()
+
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_version_check_usage
+ exit 0
+ ;;
+ --)
+ shift
+ break
+ ;;
+ -*)
+ die "invalid argument: %s" "$1"
+ ;;
+ *)
+ pkgbases=("$@")
+ break
+ ;;
+ esac
+ done
+
+ if ! command -v nvchecker &>/dev/null; then
+ die "The \"$_DEVTOOLS_COMMAND\" command requires 'nvchecker'"
+ fi
+
+ # Check if used without pkgbases in a packaging directory
+ if (( ${#pkgbases[@]} == 0 )); then
+ if [[ -f PKGBUILD ]]; then
+ pkgbases=(".")
+ else
+ pkgctl_version_check_usage
+ exit 1
+ fi
+ fi
+
+ for path in "${pkgbases[@]}"; do
+ pushd "${path}" >/dev/null
+ run_nvchecker "${path}"
+ popd >/dev/null
+ done
+}
+
+run_nvchecker() {
+ local path=$1
+ local pkgbase latest_version
+
+ if [[ ! -f ".nvchecker.toml" || ! -f "PKGBUILD" ]]; then
+ die "No .nvchecker.toml or PKGBUILD found for ${path}"
+ exit 1
+ fi
+
+ # TODO: parse .SRCINFO file
+ # shellcheck source=contrib/makepkg/PKGBUILD.proto
+ . ./PKGBUILD
+ pkgbase=${pkgbase:-$pkgname}
+
+ latest_version=$(nvchecker -c .nvchecker.toml --logger json | jq --raw-output 'select( .version ) | .version')
+ if (( $(vercmp "${latest_version}" "${pkgver}") > 0 )); then
+ msg2 "New ${pkgbase} version ${latest_version} is available upstream"
+ fi
+}
diff --git a/src/pkgctl.in b/src/pkgctl.in
index 070e0cd..9deb4b2 100644
--- a/src/pkgctl.in
+++ b/src/pkgctl.in
@@ -27,7 +27,7 @@ usage() {
release Release step to commit, tag and upload build artifacts
repo Manage Git packaging repositories and their configuration
search Search for an expression across the GitLab packaging group
- version Show pkgctl version information
+ version Package version related commands
OPTIONS
-h, --help Show this help text
@@ -39,6 +39,12 @@ if (( $# < 1 )); then
exit 1
fi
+pkgctl_version_print() {
+ cat <<- _EOF_
+ pkgctl @buildtoolver@
+_EOF_
+}
+
export _DEVTOOLS_COMMAND='pkgctl'
setup_workdir
@@ -114,14 +120,20 @@ while (( $# )); do
pkgctl_search "$@"
exit 0
;;
- version|--version|-V)
+ version)
_DEVTOOLS_COMMAND+=" $1"
shift
- # shellcheck source=src/lib/version/version.sh
- source "${_DEVTOOLS_LIBRARY_DIR}"/lib/version/version.sh
+ # shellcheck source=src/lib/version.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/version.sh
pkgctl_version "$@"
exit 0
;;
+ --version|-V)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ pkgctl_version_print
+ exit 0
+ ;;
*)
die "invalid command: %s" "$1"
;;